<?php

global $amp_conf;
global $db;

$update = 0;

if(php_sapi_name() == 'cli' || empty($_SERVER['REMOTE_ADDR'])) {
    $newline="\n";
} else {
    $newline="<br/>";
}

require_once($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/functions.inc.php");

$alldbfields = Array();
$alldbfields['customastdb']="ALTER TABLE `fop2buttons` ADD `customastdb` varchar(50) default '' AFTER originatechannel";
$alldbfields['spyoptions']="ALTER TABLE `fop2buttons` ADD `spyoptions` varchar(100) default '' AFTER customastdb";
$alldbfields['channel']="ALTER TABLE `fop2buttons` ADD `channel` varchar(200) default '' AFTER mailbox";
$alldbfields['external']="ALTER TABLE `fop2buttons` ADD `external` varchar(100) default '' AFTER spyoptions";
$alldbfields['exclude']="ALTER TABLE `fop2buttons` ADD `exclude` int(2) NOT NULL default 0 AFTER id";
$alldbfields['tags']="ALTER TABLE `fop2buttons` ADD `tags` varchar(255) default '' AFTER external";
$alldbfields['sortorder']="ALTER TABLE `fop2buttons` ADD `sortorder` int(6) NOT NULL default 0 AFTER exclude";

// Update database schema if updating from 1.1
$results = $db->getAll("DESC fop2buttons", DB_FETCHMODE_ASSOC);

if(DB::IsError($results)) {
    die($results->getMessage());
}

$existdbfield = Array();
foreach ($results as $result) {
    $campo = $result['Field'];
    $existdbfield[$campo]=1;
}

foreach($alldbfields as $campo=>$query) {
    if(!isset($existdbfield[$campo])) {
        sql($query);
        if($campo=="customastdb") { $update=1; }
        echo "Field $campo added".$newline;
    }
}

$results = sql("DESC fop2UserGroup exten","getRow",DB_FETCHMODE_ASSOC);
$tipoqchan = strtolower($results['Type']);
if($tipoqchan <> "varchar(30)") {
	$query="ALTER TABLE `fop2UserGroup` change `exten` `exten` varchar(30)";
	sql($query);
    echo "Updated fop2UserGroup table".$newline;
}

$results = sql("DESC fop2buttons queuechannel","getRow",DB_FETCHMODE_ASSOC);
$tipoqchan = strtolower($results['Type']);
if(preg_match("/^varchar/",$tipoqchan)) {
	$query = "ALTER TABLE fop2buttons CHANGE queuechannel queuechannel text DEFAULT ''";
	sql($query);
    echo "Updated fop2buttons table".$newline;
}

$results = $db->getAll("DESC fop2permissions");
if(!$results) {
	$query = "CREATE TABLE IF NOT EXISTS `fop2permissions` (
                         `id` int(11) NOT NULL auto_increment,
                         `context_id` int(11) default NULL,
                         `name` varchar(30) default NULL,
                         `permissions` varchar(200) default NULL,
                         PRIMARY KEY  (`id`)
                         ) DEFAULT CHARSET=UTF8";
	sql($query);
    echo "Created fop2permissions table".$newline;
}

$results = $db->getAll("DESC fop2PermGroup");
if(!$results) {
	$query = "CREATE TABLE IF NOT EXISTS `fop2PermGroup` (
                         `id` int(11) NOT NULL auto_increment,
                         `name` varchar(30) default NULL,
                         `id_group` int(11) default NULL,
                         `name_group` varchar(100) default NULL,
                         PRIMARY KEY  (`id`)
                       ) DEFAULT CHARSET=UTF8";
	sql($query);
    echo "Created fop2PermGroup table".$newline;
}

$results = $db->getAll("DESC fop2templates");
if(!$results) {
	$query = "CREATE TABLE `fop2templates` (
                   `id` int(11) NOT NULL auto_increment,
                   `name` varchar(30) default NULL,
                   `permissions` varchar(200) default NULL,
                   `groups` varchar(200) default NULL,
                   `isdefault` int(6) default '0',
                   PRIMARY KEY  (`id`)
                 )   DEFAULT CHARSET=UTF8";
	sql($query);
    echo "Created fop2templates table".$newline;
}

$results = $db->getAll("DESC fop2settings");
if(!$results) {
	$query = "CREATE TABLE `fop2settings` (
                  `id` int(11) NOT NULL auto_increment,
                  `keyword` varchar(250) NOT NULL,
                  `value` text NOT NULL,
                  PRIMARY KEY  (`id`),
                  UNIQUE KEY `kw` (`keyword`)
                ) DEFAULT CHARSET=UTF8";
	$sql($query);
    echo "Created fop2settings table".$newline;
}

// ******************************************

$botonesdefinidos = fop2_list_botones();
$fopbutton        = fop2_all_freepbx_buttons();

$queuechannelString = fop2_set_queuemember_strings();

$ver = getversion();
$ver = str_replace(".","",substr($ver,0,3));

if($ver>25) {
	$qctx="from-queue";
} else {
	$qctx="from-internal";
}

foreach ($fopbutton as $devname => $datarray) {
	$tipocorto = substr($datarray['type'],0,-1);

	if($tipocorto == "extension") {
		$cfstring="CF/".$datarray['exten'];
		//           $qchanstr="Local/".$datarray['exten']."@$qctx/n";
		if(!isset($queuechannelString[$datarray['exten']])) { $queuechannelString[$datarray['exten']]=''; }
		$qchanstr = $queuechannelString[$datarray['exten']];

	} else {
		$cfstring="NULL";
		$qchanstr="NULL";
	}

	if(!isset($botonesdefinidos[$devname])) {
		if($datarray['name']=="") { $datarray['name'] = $devname;}
		$results = sql( "REPLACE INTO fop2buttons (type, device, privacy, label, exten, context, mailbox, queuechannel, customastdb) ".
			"VALUES ('$tipocorto', '$devname', '', '".mysql_real_escape_string($datarray['name'])."','".$datarray['exten']."','".$datarray['context']."','".$datarray['mailbox']."','".mysql_real_escape_string($qchanstr)."','$cfstring')");
		if(DB::IsError($results)) {
			die($results->getMessage());
		} else {
			$botonesdefinidos[$devname]=1;
		};
	} else {
		if($update==1) {
			$results = sql ( "UPDATE fop2buttons SET customastdb='$cfstring' WHERE type='$tipocorto' AND device='$devname'");
		}
	}
}


$freepbxusers = core_users_list();
// La primera extension tiene todos los permisos
if(!isset($freepbxusers)) {
	$freepbxusers = array();
}
$permisos="all";

$query = "SELECT count(*) AS existing FROM fop2users";
$results = sql($query,"getRow",DB_FETCHMODE_ASSOC);
$fopusercount = $results['existing'];

// We only want to create users on first install, not on updates
if($fopusercount<=0) {

    foreach($freepbxusers as $key=>$val) {
    	if($val[2]<>"novm") {
    		$exten = $val[0];
    		$results = sql( "SELECT id FROM fop2users WHERE exten='$exten' LIMIT 1", "getRow",DB_FETCHMODE_ASSOC);
    		if(!$results) {
    			$results = sql ("INSERT INTO fop2users (exten,secret,permissions) VALUES ('$exten','','$permisos')", "query");
    			// Las demas solo pueden discar, transferir o capturar
    			$permisos="dial,transfer,transferexternal,pickup,phonebook,preferences,hangupself,chat";
    			if(DB::IsError($results)) {
    				die($results->getMessage());
    			}
    			$results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$exten',-1)","query");
    			if(DB::IsError($results)) {
    				die($results->getMessage());
    			}
    		}
    	}
    }
}
echo $newline;
//Set operator panel web root
if(class_exists("freepbx_conf")) {
        echo "Setting operator panel web root....".$newline;
        $set["FOPWEBROOT"] = "fop2";
        $freepbx_conf =& freepbx_conf::create();
        $freepbx_conf->set_conf_values($set, true, true);
        echo "Done".$newline;;
}

