<?php /* $Id */
//Copyright (C) 2011 Nicolas Gudino <asternic@gmail.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of version 2 the GNU General Public
//License as published by the Free Software Foundation.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.


$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';
$dispnum = "fop2templates";

$tabindex=0;

//if submitting form, update database
switch ($action) {
case "add":
	$result = fop2_add_template($_POST);

	if (!$result) {
		die();
	}
	redirect_standard();
	break;
case "delete":
	$oldItem = fop2_delete_template($itemid);
	redirect_standard();
	break;
case "edit":
	$result = fop2_edit_template($itemid,$_POST);
	if (!$result) {
		die();
	}
	redirect_standard('itemid');
	break;
}

$botonesdefinidos = fop2_list_botones();
$templates        = fop2_list_templates();

$fpbx_version = preg_replace('/[^0-9]/','',getversion());

if($fpbx_version <= 290) {
    echo "\n</div>";
}

?>

<!-- right side menu -->
<div class="rnav"><ul>
    <li><a id="<?php echo ($itemid=='' ? 'current':'std') ?>" href="config.php?type=tool&display=<?php echo urlencode($dispnum)?>"><?php echo _("Add FOP2 Template") ?></a></li>
<?php
if (isset($templates)) {
	foreach ($templates as $d) {
		echo "<li><a id=\"".($itemid==$d['id'] ? 'current':'std')."\" href=\"config.php?type=tool&display=".urlencode($dispnum)."&itemid=".urlencode($d['id'])."\">{$d['name']}</a></li>";
	}
}
?>
</ul></div>

<div class="content">
<?php

if ($action == 'delete') {

	$str = sprintf("Template %s deleted",$oldItem["name"]);
	echo "<br/><h3>$str!</h3>";

} else {

	$thisItem  = fop2_get_template($itemid);
	$hisGroups = explode(",",$thisItem['groups']);
	$permisos_activos=ereg_replace(",","\n",$thisItem['permissions']);
	$delURL = $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'&action=delete';

?>
    <h2><?php echo ($itemid ? _("Edit FOP2 Template").": ".$thisItem["name"] : _("Add FOP2 Template")); ?></h2>
    <p><?php echo _("This module will let you manage FOP2 templates, that you can assign to users for easy management."); ?></p>
<?php
	if ($itemid) {
?>
    <p><a href="<?php echo $delURL ?>"><?php echo _("Delete FOP2 Template")?> '<?php echo $thisItem["name"]; ?>'</a></p>
<?php
	}
?>
<form autocomplete="off" name="edit" action="<?php $_SERVER['PHP_SELF'] ?>" method="post" onsubmit="return edit_onsubmit();">
    <input type="hidden" name="type"     value="tool">
    <input type="hidden" name="display"  value="<?php echo $dispnum?>">
    <input type="hidden" name="action"   value="<?php echo ($itemid ? 'edit' : 'add') ?>">
    <input type="hidden" name="deptname" value="<?php echo $_SESSION["AMP_user"]->_deptname ?>">
    <table>
    <tr><td colspan="2"><h5><?php echo ($itemid ? _("Edit Template") : _("Add Template")) ?><hr></h5></td></tr>

    <tr>
        <td><a href="#" class="info"><?php echo _("Name").":"?><span><?php echo _("The name for this template.")?></span></a></td>
        <td><input type="text" name="templatename" tabindex="<?php echo ++$tabindex;?>" value="<?php echo $thisItem['name'] ? htmlspecialchars($thisItem['name']) : ''; ?>" <?php echo isset($thisItem['name']) ? 'disabled' : '' ?> ></td>
    </tr>
    <tr>
        <td valign="top"><a href="#" class="info"><?php echo _("Permissions") ?>:<span><?php echo _("Permissions let you specify what actions the user will be able to perform inside Fop2. For example, if you do not want to give the users the ability to listen to ongoing calls, do not select the spy or whisper permission.") ?><br><br></span></a></td>
        <td valign="top">
            <textarea id="permissions" cols="15" rows="10" name="permissions" tabindex="<?php echo ++$tabindex;?>"><?php echo $permisos_activos;?></textarea>
        </td>
    </tr>
    <tr>
        <td>
            <a href=# class="info"><?php echo _("Permission Quick Pick")?>
                <span>
                    <?php echo _("Choose the permission you wish to include in this template.")?>
                </span>
            </a>
        </td>

        <td>
            <select onChange="insertPermission();" id="insperm" tabindex="<?php echo ++$tabindex;?>">
                 <option value=""><?php echo _("(pick permission)")?></option>
                 <?php
	$results = array( 'all', 'dial', 'hangup', 'hangupself', 'meetme', 'pickup', 'record', 'recordself', 'spy', 'transfer', 'transferexternal', 'whisper', 'queuemanager', 'queueagent', 'phonebook','chat','preferences','voicemailadmin');
	$moreresults = fop2_list_perms();

	foreach ($moreresults as $result) {
		echo "<option value='".$result['name']."'>[".$result['name']."]</option>\n";
	}
	foreach ($results as $result) {
		echo "<option value='".$result."'>".$result."</option>\n";
	}
?>
            </select>
        </td>
    </tr>
    <tr>
        <td valign="top">
            <a href="#" class="info"><?php echo _("Make Default") ?>:<span><?php echo _("Use this template by default when adding new fop2 users.") ?><br/></span></a></td>
        </td>
        <td>
            <input type=checkbox name='makedefault' <?php  echo ($thisItem['isdefault']=="1")?'checked="checked"':'' ?>' >
        </td>
    </tr>

    <tr>
        <td colspan="2">
       <br/><h5><?php echo  _("Allowed Groups")  ?><hr></h5><p><?php echo _("Select the groups you want to add to this template. If no groups are selected the user will be able to see all buttons."); ?></p>
        </td>
    </tr>

    <tr>
        <td>&nbsp;</td>
    </tr>
    <tr>
        <td colspan=2>


            <table width='500'>

<?php

	$predefined_groups = array( array ( 'id' => -1, 'name' => _("All Buttons")),
		array ('id' => -2, 'name' => _("All Extensions")),
		array('id' => -3, 'name' =>_("All Queues")),
		array('id' => -4, 'name' =>_("All Conferences")),
		array('id' => -5, 'name' =>_("All Trunks"))
	);
	$groupsdb           = fop2_list_groups(0);


	if(!is_array($groupsdb)) {
		$groupsdb = array();
	}

	$groups = array_merge($predefined_groups,$groupsdb);

	foreach ($groups as $count => $datarray) {
		echo "<tr>";
		echo "<td>".$datarray['name']."</td>";
		echo "<td><input type=checkbox name='includebot[]' value='".$datarray['id']."'";

		if(in_array($datarray['id'],$hisGroups)) {
			echo " checked ";
		}

		echo"></td>";
		echo "</tr>";
	}


?>
        </table>
        </td>
    </tr>
    <tr>
        <td colspan="2"><br><h6><input name="Submit" type="submit" value="<?php echo _("Submit Changes")?>"></h6></td>
    </tr>

    </table>
    </form>

<?php
}
?>

<script language="javascript">
<!--

var theForm = document.edit;
theForm.templatename.focus();

function checkAll() {
    field = document.edit;
    for (i = 0; i < field.length; i++) {
        field[i].checked = !field[i].checked;
    }
}

function insertPermission() {
    perm = document.getElementById('insperm').value;

    grpList=document.getElementById('permissions');
    if (grpList.value[ grpList.value.length - 1 ] == "\n") {
        grpList.value = grpList.value + perm;
    } else {
        grpList.value = grpList.value + '\n' + perm;
    }

    var myout = '';
    var mytxt = grpList.value;
    var arrmytxt=mytxt.split('\n');

    arrmytxt.sort();

    arrmytxt = unique(arrmytxt);

    for (var x=0;x<arrmytxt.length;x++) {
       if (not_empty(arrmytxt[x])) {
           myout = myout + arrmytxt[x] + '\n';
       }
    }
    grpList.value = myout;

    document.getElementById('insperm').value = '';
}

function contains(a, e) {
    for(j=0;j<a.length;j++)if(a[j]==e)return true;
    return false;
}

function unique(a) {
    tmp = new Array(0);
    for(i=0;i<a.length;i++){
        if(!contains(tmp, a[i])){
            tmp.length+=1;
            tmp[tmp.length-1]=a[i];
        }
    }
    return tmp;
}

function not_empty(value)
{ //Strips leading and trailing whitespace and tests if anything remains.
  var re = (value.replace(/^\s+|\s+$/g,'').length > 0)?true:false;
  return re;
}


function edit_onsubmit() {
    var msgEmptyUserId = "<?php echo _('Please enter a template name.')?>";
    if (isEmpty(theForm.templatename.value)) {
        return warnInvalid(theForm.userid, msgEmptyUserId);
    }

    return true;
}

//-->
</script>
