<?php /* $Id */
//Copyright (C) 2011 Nicolas Gudino <asternic@gmail.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of version 2 the GNU General Public
//License as published by the Free Software Foundation.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.


$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$itemid = isset($_REQUEST['itemid'])?$_REQUEST['itemid']:'';
$dispnum = "fop2users";

$tabindex=0;

//if submitting form, update database
switch ($action) {
case "add":
	$result = fop2_add_user($_POST);

	if (!$result) {
		die();
	}
	needreload();
	redirect_standard();
	break;
case "delete":
	$oldItem = fop2_get_user($itemid);
	fop2_del_user($itemid);
	needreload();
	redirect_standard();
	break;
case "edit":
	$result = fop2_edit_user($itemid,$_POST);
	if (!$result) {
		die();
	}
	needreload();
	redirect_standard('itemid');
	break;
}

$botonesdefinidos      = fop2_list_botones();
$users                 = fop2_list_users();
$selected_def_perm     = fop2_get_defperm();
$selected_def_group    = fop2_get_defgroup();
$selected_def_template = fop2_get_deftemplate();

$fpbx_version = preg_replace('/[^0-9]/','',getversion());

if($fpbx_version <= 290) {
    echo "\n</div>";
}

?>

<!-- right side menu -->
<div class="rnav"><ul>
    <li><a id="<?php echo ($itemid=='' ? 'current':'std') ?>" href="config.php?type=tool&display=<?php echo urlencode($dispnum)?>"><?php echo _("Add FOP2 User") ?></a></li>
<?php
if (isset($users)) {
	foreach ($users as $d) {
		echo "<li><a id=\"".($itemid==$d['id'] ? 'current':'std')."\" href=\"config.php?type=tool&display=".urlencode($dispnum)."&itemid=".urlencode($d['id'])."\">{$d['exten']}</a></li>";
	}
}
?>
</ul></div>

<div class="content">
<?php

if ($action == 'delete') {

	$str = sprintf("User %s deleted",$oldItem["exten"]);
	echo "<br/><h3>$str!</h3>";

} else {

	$thisItem   = fop2_get_user($itemid);
	$hisGroups = fop2_get_user_groups($thisItem['exten']);
	$permisos_activos=preg_replace("/,/","\n",$thisItem['permissions']);
	$delURL = $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'&action=delete';
	if(!$itemid) {
		$permisos_activos = preg_replace("/,/","\n",$selected_def_perm);
		$hisGroups = $selected_def_group;
	}

?>
    <h2><?php echo ($itemid ? _("Edit FOP2 User").": ".$thisItem["exten"] : _("Add FOP2 User")); ?></h2>
    <p><?php echo _("This module will let you manage FOP2 users and permissions, and also mark the groups the user will be able to view."); ?></p>
<?php
	if ($itemid) {
?>
    <p><a href="<?php echo $delURL ?>"><?php echo _("Delete FOP2 User")?> '<?php echo $thisItem["exten"]; ?>'</a></p>
<?php
	}
?>
<form autocomplete="off" name="edit" action="<?php $_SERVER['PHP_SELF'] ?>" method="post" onsubmit="return edit_onsubmit();">
    <input type="hidden" name="type"     value="tool">
    <input type="hidden" name="display"  value="<?php echo $dispnum?>">
    <input type="hidden" name="action"   value="<?php echo ($itemid ? 'edit' : 'add') ?>">
    <input type="hidden" name="deptname" value="<?php echo $_SESSION["AMP_user"]->_deptname ?>">
    <table>
    <tr><td colspan="2"><h5><?php echo ($itemid ? _("Edit User") : _("Add User")) ?><hr></h5></td></tr>

    <tr>
        <td><a href="#" class="info"><?php echo _("Extension").":"?><span><?php echo _("The extension number for this user.")?></span></a></td>
        <td><input type="text" name="userid" tabindex="<?php echo ++$tabindex;?>" value="<?php echo isset($thisItem['exten']) ? htmlspecialchars($thisItem['exten']) : fop2_getlastid(); ?>" <?php echo isset($thisItem['exten']) ? 'disabled' : '' ?>></td>
    </tr>
    <tr>
        <td><a href="#" class="info"><?php echo _("Secret").":"?><span><?php echo _("The secret to login to fop2. If none specified the voicemail secret will be used.")?></span></a></td>
        <td><input type="text" name="secret" tabindex="<?php echo ++$tabindex;?>" value="<?php echo htmlspecialchars(isset($thisItem['secret']) ? $thisItem['secret'] : ''); ?>"></td>
    </tr>

    <tr>
        <td>
            <a href=# class="info"><?php echo _("Template Quick Pick")?>
                <span>
                    <?php echo _("Choose a template to quickly set or change permissions and groups.")?>
                </span>
            </a>
        </td>

        <td>
            <select onChange="setTemplate();" id="settemplate" tabindex="<?php echo ++$tabindex;?>">
                 <option value=""><?php echo _("(pick template)")?></option>
                 <?php
	$templates = fop2_list_templates();
	if (isset($templates)) {
		foreach ($templates as $d) {
			echo "<option value='".$d['id']."' ";
			if(!$itemid) {
				if($selected_def_template == $d['id']) {
					echo " selected ";
				}
			}
			echo ">".$d['name']."</option>\n";
		}
	}
?>
            </select>
        </td>
    </tr>


    <tr><td colspan="2"><h5><?php echo _("Permissions") ?><hr></h5></td></tr>

    <tr>
        <td valign="top"><a href="#" class="info"><?php echo _("Permissions") ?>:<span><?php echo _("Permissions let you specify what actions the user will be able to perform inside Fop2. For example, if you do not want to give the users the ability to listen to ongoing calls, do not select the spy or whisper permission.") ?><br><br></span></a></td>
        <td valign="top">
            <textarea id="permissions" cols="15" rows="10" name="permissions" tabindex="<?php echo ++$tabindex;?>"><?php echo $permisos_activos;?></textarea>
        </td>
    </tr>
    <tr>
        <td>
            <a href=# class="info"><?php echo _("Permission Quick Pick")?>
                <span>
                    <?php echo _("Choose the permission you want to grant to the user.")?>
                </span>
            </a>
        </td>

        <td>
            <select onChange="insertPermission();" id="insperm" tabindex="<?php echo ++$tabindex;?>">
                 <option value=""><?php echo _("(pick permission)")?></option>
                 <?php
	$results = array( 'all', 'dial', 'hangup', 'hangupself', 'meetme', 'pickup', 'record', 'recordself', 'spy', 'transfer', 'transferexternal', 'queuemanager', 'queueagent', 'phonebook','chat','preferences','voicemailadmin','sms','smsmanager');
	$moreresults = fop2_list_perms();
	foreach ($moreresults as $result) {
		echo "<option value='".$result['name']."'>[".$result['name']."]</option>\n";
	}
	foreach ($results as $result) {
		echo "<option value='".$result."'>".$result."</option>\n";
	}
?>
            </select>
        </td>
    </tr>

    <tr>
        <td colspan="2">
       <br/><h5><?php echo  _("Allowed Groups")  ?><hr></h5><p><?php echo _("Select the groups you want the user to see in the panel. If no groups are selected the user will be able to see all buttons."); ?></p>
        </td>
    </tr>

    <tr>
        <td>&nbsp;</td>
    </tr>
    <tr>
        <td colspan=2>


            <table width='500'>

<?php

	$predefined_groups = array( array ( 'id' => -1, 'name' => _("All Buttons")),
		array ('id' => -2, 'name' => _("All Extensions")),
		array('id' => -3, 'name' =>_("All Queues")),
		array('id' => -4, 'name' =>_("All Conferences")),
		array('id' => -5, 'name' =>_("All Trunks"))
	);
	$groupsdb           = fop2_list_groups(0);


	if(!is_array($groupsdb)) {
		$groupsdb = array();
	}

	$groups = array_merge($predefined_groups,$groupsdb);

	foreach ($groups as $count => $datarray) {
		echo "<tr>";
		echo "<td>".$datarray['name']."</td>";
		echo "<td><input type=checkbox name='includebot[]' value='".$datarray['id']."'";

		if(in_array($datarray['id'],$hisGroups)) {
			echo " checked ";
		}

		echo"></td>";
		echo "</tr>";
	}


?>
        </table>
        </td>
    </tr>
    <tr>
        <td colspan="2"><br><h6><input name="Submit" type="submit" value="<?php echo _("Submit Changes")?>"></h6></td>
    </tr>

    </table>
    </form>
<?php
}
?>

<script language="javascript">
<!--

var theForm = document.edit;
theForm.userid.focus();

<?php
// javascript arrays for permissions and templates
echo fop2_list_templates_jsobject();
?>

function checkAll() {
    field = document.edit;
    for (i = 0; i < field.length; i++) {
        field[i].checked = !field[i].checked;
    }
}

function insertPermission() {
    perm = document.getElementById('insperm').value;

    grpList=document.getElementById('permissions');
    if (grpList.value[ grpList.value.length - 1 ] == "\n") {
        grpList.value = grpList.value + perm;
    } else {
        grpList.value = grpList.value + '\n' + perm;
    }

    var myout = '';
    var mytxt = grpList.value;
    var arrmytxt=mytxt.split('\n');

    arrmytxt.sort();

    arrmytxt = unique(arrmytxt);

    for (var x=0;x<arrmytxt.length;x++) {
       if (not_empty(arrmytxt[x])) {
           myout = myout + arrmytxt[x] + '\n';
       }
    }
    grpList.value = myout;

    document.getElementById('insperm').value = '';
}

function contains(a, e) {
    for(j=0;j<a.length;j++)if(a[j]==e)return true;
    return false;
}

function unique(a) {
    tmp = new Array(0);
    for(i=0;i<a.length;i++){
        if(!contains(tmp, a[i])){
            tmp.length+=1;
            tmp[tmp.length-1]=a[i];
        }
    }
    return tmp;
}

function not_empty(value)
{ //Strips leading and trailing whitespace and tests if anything remains.
  var re = (value.replace(/^\s+|\s+$/g,'').length > 0)?true:false;
  return re;
}

function oc(a) {
  var o = {};
  for(var i=0;i<a.length;i++) {
    o[a[i]]='';
  }
  return o;
}

function setTemplate() {
    template = document.getElementById('settemplate').value;
    eval("var nowperm = tempperm_"+template);
    eval("var nowgrp  = tempgrp_"+template);

    document.getElementById('permissions').value = nowperm.join("\n");

    field = document.forms[0].elements['includebot[]'];
    for (i = 0; i < field.length; i++) {
        if(field[i].value in oc( nowgrp )) {
            field[i].checked = 1;
        } else {
            field[i].checked = 0;
        }
    }
}

function edit_onsubmit() {
    var msgEmptyUserId = "<?php echo _('Please insert an extension number.')?>";
    var msgInvalidUserId = "<?php echo _('The extension must be numeric.')?>";

    if (isEmpty(theForm.userid.value)) {
        return warnInvalid(theForm.userid, msgEmptyUserId);
    }

    if (!isInteger(theForm.userid.value)) {
        return warnInvalid(theForm.userid, msgInvalidUserId);
    }

    return true;
}

//-->
</script>
